function onDocumentLoad()
{    
    var text = createProgramTree(hmap_data.root);
    document.getElementById("programTree").innerHTML = text;
}

function onMenuClick(blockId, tag)
{
    var block = findProgramBlockById(hmap_data.root, blockId);
    createHMapTable(block);

    var rootTag = document.getElementById("programTree");
    removeClass(rootTag, "selected");
    
    tag.className = "selected";
}

function onMenuMapClick(blockId, mapAddr, imgName, tag)
{
    var block = findProgramBlockById(hmap_data.root, blockId);

    var hmapTitle = document.getElementById("hmapTitle");
    hmapTitle.innerHTML = "Selected block \"" + block.name + "\"; address size " + mapAddr;
    
    var hmap = document.getElementById("hmapPicture");
    hmap.src = "hmaps/"+imgName;
    
    var rootTag = document.getElementById("hitMapTable");
    removeClass(rootTag, "selected");
    
    tag.className = "dataRow selected";
}

function createProgramTree(rootObj)
{
    var text="<ul>"
    
    for (var i=0;i<rootObj.children_count;i++)
    {
        text += "<li onclick='onMenuClick("+rootObj.children[i].id+", this)'>";
        text += rootObj.children[i].name + "</li>";
        if (rootObj.children[i].children_count > 0)
            text += createProgramTree(rootObj.children[i]);
    }

    text += "</ul>";
    return text;
}

function createHMapTable(block)
{  
    var html = "<tr><th>Address size</th><th>Hits</th></tr>";
    
    for (var i=0;i<block.maps_count;i++)
    {
        var onclickEvent = "onclick=\"onMenuMapClick("+block.id+","+block.maps[i].addr_size+",'"+block.maps[i].img+"',this)\"";
        html += "<tr class='dataRow'"+onclickEvent+">"
        html += "<td>";
        html += block.maps[i].addr_size;
        html += "</td><td>";
        html += block.maps[i].hits;
        html += "</td></tr>";
    }
    
    document.getElementById("hitMapTable").innerHTML = html;
}

function findProgramBlockById(root, id)
{
    if (root.id == id)
        return root;

    for (var i=0;i<root.children_count;i++)
    {
        var res = findProgramBlockById(root.children[i], id);
        if (res != -1)
            return res;
    }
    
    return -1;
}

function onNavSectionBtnClick(tag)
{
    var content = tag.parentNode.nextElementSibling;
    
    if(tag.className.indexOf("buttonClosed") >= 0)
    {
        //open section
        content.style.display = 'block';
        tag.className = "button buttonOpened";
    }
    else if(tag.className.indexOf("buttonOpened") >= 0)
    {
        //close section
        content.style.display = 'none';
        tag.className = "button buttonClosed";
    }
}

function removeClass(root, className)
{
    if(root == undefined)
        return;
        
    if(root.className != undefined)
    {
        root.className = root.className.replace(" "+className,"");
        root.className = root.className.replace(className,"");
    }

    for(var i=0;i<root.childNodes.length; i++)
    {
        removeClass(root.childNodes[i], className);
    }
}